"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const stream_1 = require("stream");
const promise_or_callback_1 = require("../promise-or-callback");
const index_buffer_1 = require("./index-buffer");
class IndexStream extends stream_1.Transform {
    constructor(requester, index, options) {
        super({
            objectMode: true,
            transform(chunk, enc, cb) {
                return __awaiter(this, void 0, void 0, function* () {
                    yield promise_or_callback_1.promiseOrCallback(() => self.buffer.add(chunk), cb);
                });
            },
            flush(cb) {
                return __awaiter(this, void 0, void 0, function* () {
                    yield promise_or_callback_1.promiseOrCallback(() => self.buffer.flush(), cb);
                });
            },
        });
        this.requester = requester;
        this.index = index;
        this.options = options;
        this.buffer = new index_buffer_1.IndexBuffer((data) => __awaiter(this, void 0, void 0, function* () {
            const resp = yield this.request({
                method: 'post',
                path: '/docs/index',
                headers: { 'content-type': 'application/json' },
                body: data,
            });
            for (const result of resp.result.value) {
                this.push(result);
            }
        }));
        const self = this;
    }
    request(req) {
        req.path = `/indexes/${this.index}${req.path}`;
        return this.requester.request(req, this.options);
    }
}
exports.IndexStream = IndexStream;
//# sourceMappingURL=index-stream.js.map