"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.jsonParser = (reviver) => {
    return (res, cb) => {
        const buf = [];
        res.on('data', (d) => buf.push(d));
        res.on('error', cb);
        res.on('end', () => {
            let error;
            let body;
            try {
                body = JSON.parse(Buffer.concat(buf).toString().trim(), reviver);
            }
            catch (err) {
                error = err;
            }
            cb(error, body);
        });
    };
};
//# sourceMappingURL=parsers.js.map